package code.kalter.longflight.space;

import code.kalter.longflight.Loader;
import code.kalter.longflight.Sprite;
import java.io.IOException;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

/**
 * Пасхалка
 *
 * @author KalterFive
 */
class Egg extends Sprite {

    private boolean alive;
    private final int maxH;

    public Egg(String path, int screenW, int maxH) throws IOException {
        this(Loader.getInstance().getImage(path), screenW, maxH);
    }

    public Egg(Image image, int screenW, int maxH) {
        super(image, (screenW - image.getWidth()) / 2, -image.getHeight());
        this.maxH = maxH;
    }

    public void paint(Graphics graph) {
        if (alive) {
            super.paint(graph);
        }
    }

    public void upd() {
        if (alive) {
            moveDown(1);
            if (getY() > maxH) {
                deactivate();
            }
        }
    }

    public void activate() {
        alive = true;
    }

    public void deactivate() {
        alive = false;
        setY(-image.getHeight());
    }
}
